{ Stair Crazy version 1 - A Plugin for JED version 8 and higher.
  Written by Craig Urquhart (UGG_BOOT). Email: cu@rpi.net.au
  Imperial Detention Center: http://www.rpi.net.au/~cu/main.html

  This is the Delphi3 code for the original Stair Crazy. I have totally
  rewritten it for version 2, due to the many bugs and 'twisted logic' here.
  I'm amazed that it even worked at all. I wouldn't recommend using it as I'm
  only including it to provide a laugh for those who can read Pascal. }


unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, ShellAPI, ComObj;

type
  TForm1 = class(TForm)
    SurfaceText: TLabel;
    MatText: TLabel;
    IDCLinkPic: TImage;
    ClearMultiButton: TButton;
    MatButton: TButton;
    CreateButton: TButton;
    SGrid: TStringGrid;
    MatPanel: TPanel;
    StepHeight: TEdit;
    StepHeightText: TLabel;
    VList: TListBox;
    NormalCheck: TCheckBox;
    NormalText: TLabel;
    MetalCheck: TCheckBox;
    MetalText: TLabel;
    DirtCheck: TCheckBox;
    DirtText: TLabel;
    VTemp: TListBox;
    procedure IDCLinkPicDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClearMultiButtonClick(Sender: TObject);
    procedure Selections;
    procedure MatButtonClick(Sender: TObject);
    procedure CreateButtonClick(Sender: TObject);
    procedure NormalCheckMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MetalCheckMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DirtCheckMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function VTest(sc, sf: integer): Boolean;
end;

type
    TCoord = record
    X: double;
    Y: double;
    Z: double;
end;

var
  Form1: TForm1;
  Jed: variant;
  MultiSF, MultiVX, ClickOnce: integer;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
     try
     Jed := CreateOleObject('JED.App');
     except
         ShowMessage('START JED (v8+) BEFORE USE');
         Application.Terminate;
     end;
     if Jed.Version < 0.8 then
     begin
          ShowMessage('REQUIRES VERSION 8 OR HIGHER');
          Application.Terminate;
     end;
     MatPanel.Caption := 'dflt.mat';
     StepHeight.Text := '0.025';
     Selections;
end;

procedure TForm1.IDCLinkPicDblClick(Sender: TObject);
var
   URLLink: PChar;
begin
     URLLink := 'http://www.rpi.net.au/~cu/main.html';
     ShellExecute(0, Nil, URLLink, Nil, Nil, SW_NORMAL);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
   hndl: Hwnd;
begin
     SendMessage(hndl, WM_CLOSE, 0, 0);
end;

procedure TForm1.ClearMultiButtonClick(Sender: TObject);
var
   n: integer;
begin
     for n := 0 to 6 do Jed.ClearMultiselection(n);
     Selections;
end;

procedure TForm1.Selections;
var
   n, r, col, row, sc, sf: integer;
begin
     CreateButton.Caption := 'CREATE';
     VList.Clear;
     col := 0;
     row := 0;
     ClickOnce := 0;
     Jed.MapMode := 1;
     MultiSF:= Jed.NMultiSelected(1);
     Jed.MapMode := 2;
     MultiVX := Jed.NMultiSelected(2);
     for r:= 0 to (SGrid.RowCount - 1) do
     begin
          SGrid.Cells[0,r] := '';
          SGrid.Cells[1,r] := '';
          SGrid.Cells[2,r] := '';
     end;
     SGrid.RowCount := 3;
     if MultiSF > 0 then
     begin
          for n := 0 to (MultiSF - 1) do
          begin
               Jed.GetSelectedSF(n, sc, sf);
               if VTest(sc, sf) then
               begin
                    SGrid.Cells[col,row] := IntToStr(sc) + ' ' + IntToStr(sf);
                    col := col + 1;
                    if col = 3 then
                    begin
                         col := 0;
                         SGrid.RowCount := SGrid.RowCount + 1;
                         row := row + 1;
                    end;
                    VList.Items.Add(IntToStr(sc));
                    VList.Items.Add(IntToStr(sf));
                    VList.Items.Add(VTemp.Items[0]);
                    VList.Items.Add(VTemp.Items[1]);
                    VList.Items.Add(VTemp.Items[2]);
                    VList.Items.Add(VTemp.Items[3]);
               end;
          end;
     end
     else
     begin
          ShowMessage('NO SURFACES HAVE BEEN SELECTED');
          Application.Terminate;
     end;
end;

procedure TForm1.MatButtonClick(Sender: TObject);
var
   material: string;
begin
     material := MatPanel.Caption;
     MatPanel.Caption := Jed.PickMAT(material);
end;

procedure TForm1.CreateButtonClick(Sender: TObject);
var
   sc, sca, sf, sfa, numsteps, v1, v2, v1old, v2old, v1e, v2e: integer;
   surfflag, temp, n, Count, varcheck: integer;
   secobj, newsecobj, surfobj, newsurfobj: variant;
   S1, S2, E1, E2, T1, T2, S1D, S2D: TCoord;
   X, Y, Z: double;
begin
     varcheck := 0;
     Count := 0;
     if ClickOnce = 2 then Application.Terminate
     else if ClickOnce = 0 then
     while Count < VList.Items.Count do
     begin
          CreateButton.Caption := 'WAIT';
          ClickOnce := 1;
          sc := StrToInt(VList.Items[Count]);
          sf := StrToInt(VList.Items[Count + 1]);
          v1old := StrToInt(VList.Items[Count + 2]);
          Jed.Level.GetSector(sc).GetVertex(v1old, S1.X, S1.Y, S1.Z);
          v2old := StrToInt(VList.Items[Count + 3]);
          Jed.Level.GetSector(sc).GetVertex(v2old, S2.X, S2.Y, S2.Z);
          v1e := StrToInt(VList.Items[Count + 4]);
          Jed.Level.GetSector(sc).GetVertex(v1e, E1.X, E1.Y, E1.Z);
          v2e := StrToInt(VList.Items[Count + 5]);
          Jed.Level.GetSector(sc).GetVertex(v2e, E2.X, E2.Y, E2.Z);
          Count := Count + 6;
          if S1.Z > S2.Z then
          begin
               T1 := S1;
               temp := v1old;
               S1 := S2;
               v1old := v2old;
               S2 := E1;
               v2old := v1e;
               E1 := E2;
               v1e := v2e;
               E2 := T1;
               v2e := temp;
          end;
          if S1.Z < E1.Z then
          begin
               T1 := S1;
               temp := v1old;
               S1 := E2;
               v1old := v2e;
               E2 := T1;
               v2e := temp;
               T2 := S2;
               temp := v2old;
               S2 := E1;
               v2old := v1e;
               E1 := T2;
               v1e := temp;
          end;
          if (S1.X - S2.X) < 0 then
          begin
               if (S1.Y - E2.Y) < 0 then
               begin
                    T1 := S1;
                    temp := v1old;
                    S1 := S2;
                    v1old := v2old;
                    S2 := T1;
                    v2old := temp;
                    T2 := E1;
                    temp := v1e;
                    E1 := E2;
                    v1e := v2e;
                    E2 := T2;
                    v2e := temp;
               end;
          end
          else if (S1.X - S2.X) > 0 then
          begin
               if (S1.Y - E2.Y) > 0 then
               begin
                    T1 := S1;
                    temp := v1old;
                    S1 := S2;
                    v1old := v2old;
                    S2 := T1;
                    v2old := temp;
                    T2 := E1;
                    temp := v1e;
                    E1 := E2;
                    v1e := v2e;
                    E2 := T2;
                    v2e := temp;
               end;
          end
          else if (S1.X - S2.X) = 0 then
          begin
               if (S1.Y - S2.Y) < 0 then
               begin
                    if (S1.X - E2.X) > 0 then
                    begin
                         T1 := S1;
                         temp := v1old;
                         S1 := S2;
                         v1old := v2old;
                         S2 := T1;
                         v2old := temp;
                         T2 := E1;
                         temp := v1e;
                         E1 := E2;
                         v1e := v2e;
                         E2 := T2;
                         v2e := temp;
                    end;
               end
               else if (S1.Y - S2.Y) > 0 then
               begin
                    if (S1.X - E2.X) < 0 then
                    begin
                         T1 := S1;
                         temp := v1old;
                         S1 := S2;
                         v1old := v2old;
                         S2 := T1;
                         v2old := temp;
                         T2 := E1;
                         temp := v1e;
                         E1 := E2;
                         v1e := v2e;
                         E2 := T2;
                         v2e := temp;
                    end;
               end;
          end;
          if S1.Z <> S2.Z then ShowMessage('SURFACE '+IntToStr(sc)+' '
                               +IntToStr(sf)+' CANNOT BE USED')
          else if E1.Z <> E2.Z then ShowMessage('SURFACE '+IntToStr(sc)+' '
                               +IntToStr(sf)+' CANNOT BE USED')
          else if S1.Z = E1.Z then ShowMessage('SURFACE '+IntToStr(sc)+' '
                               +IntToStr(sf)+' CANNOT BE USED')
          else
          begin
               varcheck := 1;
               numsteps := Abs(Round((E2.Z - S1.Z) / StrToFloat(StepHeight.Text)));
               S1D.X := (E2.X - S1.X) / numsteps;
               S1D.Y := (E2.Y - S1.Y) / numsteps;
               S1D.Z := (E2.Z - S1.Z) / numsteps;
               S2D.X := (E1.X - S2.X) / numsteps;
               S2D.Y := (E1.Y - S2.Y) / numsteps;
               S2D.Z := S1D.Z;
               secobj := Jed.Level.GetSector(sc);
               secobj.DeleteSurface(sf);
               secobj.Update;
               sca := sc;
               if MetalCheck.Checked = True then surfflag := 65541
               else if DirtCheck.Checked = True then surfflag := 524293
               else surfflag := 5;
               for n := 1 to numsteps do
               begin
                    if n = numsteps then
                    begin
                         v1 := v2e;
                         v2 := v1e;
                    end
                    else
                    begin
                         T1.X := S1.X + S1D.X*n;
                         T1.Y := S1.Y + S1D.Y*n;
                         T1.Z := S1.Z + S1D.Z*n;
                         T2.X := S2.X + S2D.X*n;
                         T2.Y := S2.Y + S2D.Y*n;
                         T2.Z := S2.Z + S2D.Z*n;
                         v1 := secobj.AddVertex(T1.X, T1.Y, T1.Z);
                         v2 := secobj.AddVertex(T2.X, T2.Y, T2.Z);
                    end;
                    sf := secobj.AddSurface;
                    sfa := sf;
                    surfobj := secobj.GetSurface(sf);
                    surfobj.InsertVertex(0,v1old);
                    surfobj.InsertVertex(1,v1);
                    surfobj.InsertVertex(2,v2);
                    surfobj.InsertVertex(3,v2old);
                    surfobj.Update;
                    sc := Jed.Level.AddSector;
                    newsecobj := Jed.Level.GetSector(sc);
                    newsecobj.AddSurface;
                    newsecobj.AddSurface;
                    newsecobj.AddSurface;
                    newsecobj.AddSurface;
                    newsecobj.AddSurface;
                    secobj.GetVertex(v1old, X, Y, Z);
                    newsecobj.AddVertex(X, Y, Z);
                    newsecobj.AddVertex(X, Y, (Z + S1D.Z));
                    secobj.GetVertex(v2old, X, Y, Z);
                    newsecobj.AddVertex(X, Y, Z);
                    newsecobj.AddVertex(X, Y, (Z + S2D.Z));
                    secobj.GetVertex(v1, X, Y, Z);
                    newsecobj.AddVertex(X, Y, Z);
                    secobj.GetVertex(v2, X, Y, Z);
                    newsecobj.AddVertex(X, Y, Z);
                    newsecobj.Update;
                    newsurfobj := newsecobj.GetSurface(1);
                    newsurfobj.InsertVertex(0, 0);
                    newsurfobj.InsertVertex(0, 1);
                    newsurfobj.InsertVertex(0, 4);
                    newsurfobj.Material := MatPanel.Caption;
                    newsurfobj.Update;
                    newsurfobj := newsecobj.GetSurface(2);
                    newsurfobj.InsertVertex(0, 2);
                    newsurfobj.InsertVertex(0, 5);
                    newsurfobj.InsertVertex(0, 3);
                    newsurfobj.Material := MatPanel.Caption;
                    newsurfobj.Update;
                    newsurfobj := newsecobj.GetSurface(3);
                    newsurfobj.InsertVertex(0, 0);
                    newsurfobj.InsertVertex(0, 2);
                    newsurfobj.InsertVertex(0, 3);
                    newsurfobj.InsertVertex(0, 1);
                    newsurfobj.Material := MatPanel.Caption;
                    newsurfobj.Update;
                    newsurfobj := newsecobj.GetSurface(4);
                    newsurfobj.InsertVertex(0, 1);
                    newsurfobj.InsertVertex(0, 3);
                    newsurfobj.InsertVertex(0, 5);
                    newsurfobj.InsertVertex(0, 4);
                    newsurfobj.Material := MatPanel.Caption;
                    newsurfobj.SurfFlags := surfflag;
                    newsurfobj.Update;
                    newsurfobj := newsecobj.GetSurface(0);
                    newsurfobj.InsertVertex(0, 0);
                    newsurfobj.InsertVertex(0, 4);
                    newsurfobj.InsertVertex(0, 5);
                    newsurfobj.InsertVertex(0, 2);
                    newsurfobj.Material := MatPanel.Caption;
                    surfobj.SetFlags(7, 0, 0);
                    surfobj.SetGeoLightTex(0, 3, 1);
                    newsurfobj.SetFlags(7, 0, 0);
                    newsurfobj.SetGeoLightTex(0, 3, 1);
                    surfobj.SetAdjoin(sc, 0);
                    newsurfobj.SetAdjoin(sca, sfa);
                    surfobj.Update;
                    newsurfobj.Update;
                    secobj.Update;
                    newsecobj.Update;
                    v1old := v1;
                    v2old := v2;
               end;
          end;
          if varcheck = 1 then
          begin
               surfobj.Release;
               newsurfobj.Release;
               secobj.Release;
               newsecobj.Release;
          end;
          ClickOnce := 2;
          CreateButton.Caption := 'DONE';
    end;
end;

function TForm1.VTest(sc, sf: integer): Boolean;
var
   sc1, vx, m: integer;
begin
     VTest := True;
     VTemp.Clear;
     Jed.MapMode := 2;
     for m := 0 to (MultiVX - 1) do
     begin
          Jed.GetSelectedVX(m, sc1, vx);
          if sc1 = sc then VTemp.Items.Add(IntToStr(vx));
     end;
     if VTemp.Items.Count <> 4 then
     begin
          VTest := False;
          ShowMessage('SURFACE '+IntToStr(sc)+' '+IntToStr(sf)+
                      ' CANNOT BE USED');
     end;
end;

procedure TForm1.NormalCheckMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     NormalCheck.Checked := True;
     MetalCheck.Checked := False;
     DirtCheck.Checked := False;
end;

procedure TForm1.MetalCheckMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     MetalCheck.Checked := True;
     NormalCheck.Checked := False;
     DirtCheck.Checked := False;
end;

procedure TForm1.DirtCheckMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     DirtCheck.Checked := True;
     NormalCheck.Checked := False;
     MetalCheck.Checked := False;
end;

end.
